#! CRADDON 1
#! NAME Search And Replace
#! DESCRIPTION Search and replace different tags in your newsitems
#! VERSION 1.0
#! HOMEPAGE http://www.parahead.com/coranto/
#! DOC 1

$::SearchAndReplace_build = 1;

my $addon = new Addon('Search And Replace');
$addon->checkBuild(28);
if ($crcgiBuild > 31) {$addon->isPrivacyCompatible;} 

$addon->registerAdminFunction('searchandreplace', 'SAR_SearchList');
$addon->registerAdminFunction('searchandreplace_save', 'SAR_Save');
$addon->addAdminFunction('Search & Replace', 'Edit the Search & Replace', 'searchandreplace');


{
my $SARFilter = '';
sub SAR_Filter {
	# Only instanciate the search and replace regexp once...
	SAR_InitFilter(\$SARFilter) unless($SARFilter);
	&$SARFilter;
}
}
$addon->hook('Build_GetData', 'SAR_Filter', 5);
$addon->hook('ViewNews_2', 'SAR_Filter', 5);

sub SAR_InitFilter {
	my ($filterRef) = @_;

	my $expr = '';
	# Read the search and replace data from file
	my %ProblemRegexp;
	my @SAR_Replace = ();
	&SAR_ReadInfo(\@SAR_Replace);
	my ($RegExp, $Key,$SearchText,$ReplaceText,$WholeWords,$FirstInstance,$NoCase,$NoQuote,$Fields);
	foreach $i (@SAR_Replace) {
		($Key,$SearchText,$ReplaceText,$WholeWords,$FirstInstance,$NoCase,$NoQuote,$Fields) = split /!x!/,$i;

		$RegExp = ' =~ s';
		$SearchText =~ s'/'\/'g unless $NoQuote;
		$ReplaceText =~ s'/'\/'g unless $NoQuote;
		if ($SearchText =~ m/\(\#\#\)/) {
			$SearchText =~ s/(.*?)\(\#\#\)(.?)/$1.SAR_CreateRE($2, $NoQuote).$2/ge;
			$SearchText = ($NoQuote?'':'\Q') . $SearchText . ($NoQuote?'':'\E');
			$SearchText =~ s/\\Q\\E$//;
			$ReplaceText =~ s/\(\#(\d+)\#\)/\$$1/g;
			
			$RegExp .= '/'. $SearchText . '/' . $ReplaceText . '/';
		} else {
			if ($WholeWords) {
				$RegExp .= '/([^\w\d\<]|\A)' . ($NoQuote?'':'\Q');
				$RegExp .= $SearchText;
				$RegExp .= ($NoQuote?'':'\E') . '([^\w\d\>]|\Z)';
				$RegExp .= '/$1' . $ReplaceText . '$2/';

			} else {
				$RegExp .= '/' . ($NoQuote?'':'\Q') . $SearchText . ($NoQuote?'':'\E');
				$RegExp .= '/' . $ReplaceText . '/';
			}
		}
		$RegExp .= 'g' unless $FirstInstance;
		$RegExp .= 'i' if $NoCase;
		$RegExp .= 'o;';
			
		my (@fields) = split /\|x\|/,$Fields;
		foreach $Field (@fields) {
			$expr .= "\$$Field$RegExp";
			$ProblemRegexp{"$SearchText"} = "\$$Field$RegExp";
#print "DEBUG MESSAGE RegExp: " . HTMLescape("\$$Field$RegExp") . "<br>\n";		
		}
	}
	$$filterRef = eval "sub { $expr }";
	if ($@) {
		my $search;
		foreach $reg(keys %ProblemRegexp) {
			eval "$ProblemRegexp{$reg}";
			if($@) {
				$search = $reg;
				last;
			}
		}
		CRcough("<b>The addon 'Search And Replace' encountered a problem for the search text:</b><br>" . HTMLescape($search) . "<br><br><b>The Regular expression was:</b><br>" . HTMLescape($ProblemRegexp{$search}) . "<br><br><b>Full errormessage:</b> $@", 1);
	}
}


sub SAR_CreateRE {
	my ($Text, $NoQuote) = @_;
	$Text =~ s/(\A)/$1/;
	$Text = '\Z' if $Text eq '';
	$Text = '\s' if $Text eq ' ';
	$Text =~ s/\A(\W)\Z/\\$1/;
	return ($NoQuote?'':'\E') . '([^' . $Text . ']+)' . ($NoQuote?'':'\Q');
}





# Reads from file into @$rayref
$Subs{'SAR_ReadInfo'} = << 'END_SUB';
sub SAR_ReadInfo {
	my ($rayref) = @_;

	$CConfig{'sar_replacefile'} ||= $CConfig{data_path}?qq~$CConfig{data_path}/searchandreplace.txt~:qq~$CConfig{admin_path}/searchandreplace.txt~;
	my $filename = $CConfig{'sar_replacefile'};
	
	@$rayref = ();
	unless( -e $filename ) {
		my $file = CRopen(">$filename");
		print $file '';
		close($file);
		return;
	}
	my $file = CRopen($filename);
	@$rayref = ();
	my $num = 0;
	while( <$file> ) {
		chomp($_);
		$$rayref[$num] = $_;
		$num++;
	}
	close($file);
}
END_SUB



# Saves @$rayref to file
sub SAR_WriteInfo {
	my ($rayref) = @_;
	
	$CConfig{'sar_replacefile'} ||= $CConfig{data_path}?qq~$CConfig{data_path}/searchandreplace.txt~:qq~$CConfig{admin_path}/searchandreplace.txt~;
	my $filename = $CConfig{'sar_replacefile'};
	my $file = CRopen(">$filename");
	for( my $num = 0; $num < @$rayref; $num++ ) {
		print $file $$rayref[$num] . qq~\n~;
	}
	close($file);
}






##############################################################################
# Search And Replace Administration
##############################################################################
$Subs{SAR_SearchList} = <<'END_SUB';
sub SAR_SearchList {
	my ($addon) = @_;
	my $message = qq~<p>To add a new entry, use the blank fields provided at the bottom. (If you fill the available blank fields, click Submit Changes and then edit Search And Replace again. Four new blank fields will be available.)
					<p>To delete an entry, delete everything in the 'Search For Text' field and press Save.
					<p>You can use (##) => (#1#) to symbolize wild characters, please refer to the documentation for more examples of this. ~;

	my @SAR_Replace = ();
	
	NeedCFG();
	&SAR_ReadInfo(\@SAR_Replace);
	
	$addon->pageHeader('Edit Search And Replace', 1);
	print qq~<table width="75%" align="center" border="0" cellpadding="2" cellspacing="2" class="description"><tr><td width="15%" align="center" valign="top"><font size="6"><b>?</font><br>info</b></td><td width="85%" valign="top"><div align="justify">$message</div></td></tr></table>~;
	print $addon->form({action=>'admin', adminarea=>'searchandreplace_save'});
	print q~
	<br>
	<table width="100%" border="0" cellpadding="2" cellspacing="2">
		<tr class="fieldtitle">
		<td colspan="2" width="40%" align="center">Search For</td>
		<td colspan="2" width="40%" align="center">Replace With</td>
		<td width="20%" align="center">In Which Fields?</td></tr>
	~;
	my $count = 0;
	foreach $i (@SAR_Replace) {
		my ($Key,$SearchText,$ReplaceText,$WholeWords,$FirstInstance,$NoCase,$NoQuote,$Fields) = split /!x!/,$i;
		
		$count++;
		$SearchText		= HTMLescape($SearchText);
		$ReplaceText	= HTMLescape($ReplaceText);
		$WholeWords		= ($WholeWords ? ' checked' : '');
		$FirstInstance	= ($FirstInstance ? ' checked' : '');
		$NoCase			= ($NoCase ? ' checked' : '');
		$NoQuote		= ($NoQuote ? ' checked' : '');
		
		my $fieldList = '';
		my %selFields = ();
	    foreach $_ (split /\|x\|/,$Fields) { 
	        $selFields{$_} = 1;
	    } 
		foreach $i (@fieldDB) {
			$fieldList .= qq~<option value="$i"~ . ($selFields{$i} ? ' selected':'') . qq~>$i</option>~;
		}
		print qq~
		<tr>
		<td colspan="2" width="40%" align="center"><textarea cols="40" rows="3" name="SARList_${count}_Search">$SearchText</textarea></td>
		<td colspan="2" width="40%" align="center"><textarea cols="40" rows="3" name="SARList_${count}_Replace">$ReplaceText</textarea></td>
		<td width="20%" align="center"><select multiple size="3" name="SARList_${count}_Fields">$fieldList</select></td>
		</tr>
		<tr>
		<td colspan="5"><table width="100%"><tr>
		<td width="20%" align="center"><input type="checkbox" name="SARList_${count}_WholeWords"$WholeWords><em>Whole Words Only?</em></td>
		<td width="20%" align="center"><input type="checkbox" name="SARList_${count}_FirstInstance"$FirstInstance><em>First Instance Only?</em></td>
		<td width="20%" align="center"><input type="checkbox" name="SARList_${count}_NoCase"$NoCase><em>Case Insensitive?</em></td>
		<td width="20%" align="center"><input type="checkbox" name="SARList_${count}_NoQuote"$NoQuote><em>Allow Metacharacters?</em></td>
		</tr></table></td>
		</tr>
		<tr>
		<td colspan="5"><hr></td>
		</tr>
		~;

	}
	my $extraCount = $count;
	my $allFields = '';
	foreach $i (@fieldDB) {
		$allFields .= qq~<option value="$i">$i</option>~;
	}
	
	do {
		$extraCount++;
		print qq~
		<tr>
		<td colspan="2" width="40%" align="center"><textarea cols="40" rows="3" name="SARList_${extraCount}_Search"></textarea></td>
		<td colspan="2" width="40%" align="center"><textarea cols="40" rows="3" name="SARList_${extraCount}_Replace"></textarea></td>
		<td width="20%" align="center"><select multiple size="3" name="SARList_${extraCount}_Fields">$allFields</select></td>
		</tr>
		<tr>
		<td colspan="5"><table width="100%"><tr>
		<td width="20%" align="center"><input type="checkbox" name="SARList_${extraCount}_WholeWords"><em>Whole Words Only?</em></td>
		<td width="20%" align="center"><input type="checkbox" name="SARList_${extraCount}_FirstInstance"><em>First Instance Only?</em></td>
		<td width="20%" align="center"><input type="checkbox" name="SARList_${extraCount}_NoCase"><em>Case Insensitive?</em></td>
		<td width="20%" align="center"><input type="checkbox" name="SARList_${extraCount}_NoQuote"><em>Allow Metacharacters?</em></td>
		</tr></table></td>
		</tr>
		<tr>
		<td colspan="5"><hr></td>
		</tr>
		~;
	}
	until $extraCount == $count + 5;
	print '</table><br><table width="80%" align="center" border="0" cellpadding="2" cellspacing="2" class="description"><tr><td width="100%" align="center" valign="top"><input type="submit" value="Save"> <input type="reset"></td></tr></table></form>';
	$addon->pageFooter;
}
END_SUB







# SAR_Save: Saves changes made in Search And Replace
$Subs{'SAR_Save'} = << 'END_SUB';
sub SAR_Save {
	my $addon = shift;
	
	@SAR_Replace = ();
	for( my $i = 1; exists $in{"SARList_${i}_Search"} && exists $in{"SARList_${i}_Replace"}; $i++ ) {
		$in{"SARList_${i}_Search"} =~ s/\Q|x|\E//g;
		$in{"SARList_${i}_Search"} =~ s/\n//g;
		$in{"SARList_${i}_Replace"} =~ s/\Q|x|\E//g;
		$in{"SARList_${i}_Replace"} =~ s/\n//g;
		if( $in{"SARList_${i}_Search"} eq '' ) { next; }
		my $fields = $in{"SARList_${i}_Fields"} || 'Text';
		push(@SAR_Replace, join('!x!', "sar$i", $in{"SARList_${i}_Search"}, $in{"SARList_${i}_Replace"}, $in{"SARList_${i}_WholeWords"}, $in{"SARList_${i}_FirstInstance"}, $in{"SARList_${i}_NoCase"}, $in{"SARList_${i}_NoQuote"}, $fields) );
	}
	
	&SAR_WriteInfo( \@SAR_Replace );
	
	$addon->simplePage('Search And Replace Saved', 'Your changes to the Search And Replace list have been saved.<br>' .
		$addon->link({'action' => 'admin', 'adminarea' => 'searchandreplace'}) .
		'Back to Edit Search And Replace</a>.', 1);
}
END_SUB






1;

__END__

=head1 Search & Replace

=head2 BACKGROUND

I first thought about naming this addon Flying Rice, because the functionality is pretty much the same as for
the Anne Rice addon but this addon does it on the fly when building news. Slower yes, but less error prone.
Anyway, I took a second to think about that name and came to the conclusion that it wasn't really intuitive and
that it would be hard to guess what the addon actually did with a name like that, so I decided to use 'Search &
Replace' instead, dull but much more describing...

=head2 BASIC USAGE

After you have enabled the addon you will find a new option at the Adminstration page called 'Search And Replace',
click on that and you will find yourself on a page with a matrix of setting fields. Each line represent a group
of fields that is used for one substitution. It should be quite obvious how to use the fields, but a short note
on each of them:

=over *

=item *

Search For - The text to search for.

=item *

Replace With - And the text to replace it with.

=item *

In Which Fields? - This match should be performed on which fields?

=item *

Whole Words Only - Should we match all occurances of the text or hole words only?

=item *

Replace First Instance Only - Should we replace all occurances of the text, or only the first one?

=item *

Case Insensitive - Should we perform a case insensitive match or not?

=item *

Allow Metacharacters - This option let you to use all metacharacters available in regular expressions. (Advanced Users Only!)

=back

An example of use for Search And Replace is to simulate BBcode tags in the textarea.

	Search For: :lol:
	Replace With: <img src="images/smiles/icon_lol.gif" alt="Laughing" border="0" />
	In Which Fields? Text
	[ ] Whole Words Only? [ ] Replace First Instance Only? [X] Case Insensitive? [ ] Allow Metacharacters?


=head2 WILD CARD MATCH

Search and Replace also contains a feature to do wild card matching, it pretty much works the same way
as it does for the Anne Rice or iSay addons. Basically you can define a wild card on the search-side as well
as on the replace-side. An example would be:

	Search For: [url=(##)](##)[/url]
	Replace With: <a href="(#1#)">(#2#)</a>
	In Which Fields? Text
	[ ] Whole Words Only? [ ] Replace First Instance Only? [X] Case Insensitive? [ ] Allow Metacharacters?

=head2 ALLOWING METACHARACTERS

This option is for advanced users only and if you don't consider yourself to be familiar with regular expressions 
you should not touch this option but instead leave it unchecked, OK!? If you continue reading, you will find a
small technical description of what this option does.

Normally when the 'Search And Replace' addon creates the regular expression the Search string is encapsulated
within the \Q and \E metacharacters, thus quoting (or disabling) all metacharacters. With this option checked
there isn't any \Q placed in the regexp and you can perform normal regular expressions like you are used to,
without limitations. Please note that the substitution is using slashes as delimiters, in the format s///;

If you want to read more about regular expressions, please check out the links below.

=over *

=item *

L<http://www.perl.com/doc/manual/html/pod/perlre.html>

=item *

L<http://www.perl.com/doc/manual/html/pod/perlfaq6.html>

=back

=head2 LICENSE AND DISCLAIMER

The addon is provided on an "AS IS" basis, without warranty of any kind, either expressed or implied, including
without limitation, warranties that the addon is free of defects, merchantable, fit for a particular purpose
or non-infringing. The entire risk as to the quality and performance of the addon is with you.
Should the addon prove defective in any respect, you (not the copyright holder) assume the cost of any necessary
servicing, repair or correction. NO USE OF THE ADDON IS AUTHORIZED HEREUNDER EXCEPT UNDER THIS DISCLAIMER.

=head2 ABOUT THE AUTHOR

=over

=item *

name: Henrik Ahln aka Parahead

=item *

email: L<mailto:henrik@parahead.com>

=item *

site: L<http://www.parahead.com/coranto/>

=back

=head2 VERSION HISTORY

=head3 1.0 by Parahead (2005-07-06)

=over

=item *

First release

=back

